function y=asm8086filter2(open,high,low,close)
%y=asm8086filter2(open,high,low,close)
%
%asm8086 Filter from post #699
%http://www.forexfactory.com/showpost.php?p=3371056&postcount=699

    N=length(open);

    if(length(high)==N && length(low)==N && length(close)==N)
        if(N > 116)
            [hopen,hhigh,hlow,hclose]=HeikinAshi(open,high,low,close); %#ok<NASGU>
            x=(hhigh+hlow).*0.5;
            H0=ullma(0);
            H1=ullma(1);
            h0x=H0.filter(x);
            h1h0xd=H1.filter([0;diff(h0x)]);
            H0.States=0;
            h0h1h0xd=H0.filter(h1h0xd);
            y=h0x+(h1h0xd.*2-h0h1h0xd);
            y(1:116)=0;
        else
            error('input vectors length must be greater than 116');
        end
    else
        error('input vectors must have the same length');
    end
end

function [hopen,hhigh,hlow,hclose]=HeikinAshi(open,high,low,close)
%[hopen,hhigh,hlow,hclose]=HeikinAshi(open,high,low,close)
%
%Heikin-Ashi Indicator

    N=length(open);

    hopen=zeros(N,1);
    hhigh=zeros(N,1);
    hlow=zeros(N,1);
    hclose=zeros(N,1);

    hopen(1)=open(1);
    hhigh(1)=high(1);
    hlow(1)=low(1);
    hclose(1)=close(1);

    for n=2:N
        hclose(n)=(open(n)+close(n)+high(n)+low(n))*0.25;
        hopen(n)=(hopen(n-1)+hclose(n-1))*0.5;
        hhigh(n)=max([high(n);hopen(n);hclose(n)]);
        hlow(n)=min([low(n);hopen(n);hclose(n)]);
    end
end

function H=ullma(type)
%H=ullma(type)
%
%Codebreaker's "Ultra Low Lag Moving Average" Clone
%http://www.forexfactory.com/showthread.php?t=68181&page=10

    Length=39;

    switch(type)
        case 0
            Cycles=1.25;
        case 1
            Cycles=2.5;
        case 2
            Cycles=3.75;
        case 3
            Cycles=6.25;
        otherwise
            error('Unknown type');
    end

    x=(0:1/(Length-1):1)'.*(Cycles*pi);
    h=sinc(x);
    h=h./sum(h);
    H=dfilt.dffir(h);
end